// u_display_simple
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

unit u_23_object_analyzer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2_: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    PageControl1: TPageControl;
    display_: TTabSheet;
    analyze_: TTabSheet;
    Memo1: TMemo;
    object_listbox_: TListBox;
    Splitter2_: TSplitter;
    Panel21_: TPanel;
    Panel23_: TPanel;
    PageControl2_: TPageControl;
    fields_: TTabSheet;
    fields_listbox_: TListBox;
    Panel3_: TPanel;
    methods_: TTabSheet;
    methods_listbox_: TListBox;
    Panel3__: TPanel;
    properties_: TTabSheet;
    properties_listbox_: TListBox;
    Panel5_: TPanel;
    property_value_edit_: TEdit;
    set_property_value_: TButton;
    ancestor_listbox_: TListBox;
    Label2_: TLabel;
    Timer1: TTimer;
    Splitter2__: TSplitter;
    Panel2___: TPanel;
    tbutton_rtti_: TButton;
    Panel3____: TPanel;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    fill_object_list_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure fill_object_list_Click(Sender: TObject);
    procedure b_Click(Sender: TObject);
    procedure e_Click(Sender: TObject);
    procedure f_Click(Sender: TObject);
    procedure g_Click(Sender: TObject);
    procedure object_listbox_Click(Sender: TObject);
    procedure properties_listbox_Click(Sender: TObject);
    procedure set_property_value_Click(Sender: TObject);
    procedure tbutton_rtti_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses Rtti, u_display_simple
(*
        , u_types_constants
        , u_display_hex_2_simple
*)
        , u_display_rtti;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.tbutton_rtti_Click(Sender: TObject);
      Var l_rtti_context: tRttiContext;
          l_c_button_rtti_type: tRttiType;
          l_c_rtti_field: tRttifield;
      begin
        l_c_button_rtti_type:= l_rtti_context.GetType(tButton);
        For l_c_rtti_field In l_c_button_rtti_type.GetFields Do
          display(l_c_rtti_field.ToString);
      end; // tbutton_rtti_Click

    procedure TForm1.fill_object_list_Click(Sender: TObject);
      var l_component_index : Integer;
          l_component_name: String;
      begin
        for l_component_index:= 0 to Self.ComponentCount -1 do
        begin
          l_component_name:= Components[l_component_index].Name;
          if l_component_name[Length(l_component_name)]<> '_' then

          object_listbox_.Items.AddObject(l_component_name, Components[l_component_index]);
        end; // for l_component_index
      end; // fill_object_list_Click

    function f_c_listbox_object: tComponent;
      begin
        with Form1, object_listbox_ do
          Result:= Items.Objects[ItemIndex] as tComponent;
      end; // f_c_listbox_object

    procedure TForm1.object_listbox_Click(Sender: TObject);
      begin
        fill_ancestor_list(f_c_listbox_object, ancestor_listbox_.Items);

        fill_field_list(f_c_listbox_object, fields_listbox_.Items);
        fill_method_list(f_c_listbox_object, methods_listbox_.Items);
        fill_property_list(f_c_listbox_object,  properties_listbox_.Items);
      end; // object_listbox_Click

    procedure TForm1.properties_listbox_Click(Sender: TObject);
      begin
        with properties_listbox_ do
          property_value_edit_.Text:=
            f_property_string_value(f_c_listbox_object, Items[ItemIndex]);
      end; // properties_listbox_Click

    procedure TForm1.set_property_value_Click(Sender: TObject);
      begin
        with properties_listbox_ do
          set_property_value(f_c_listbox_object, Items[ItemIndex], property_value_edit_.Text);
      end; // set_property_value_Click

    procedure TForm1.b_Click(Sender: TObject);
        // -- check which kinds we did not analyze
      begin
        display(g_c_unknown_type_kind.Text);
      end; // b_

    procedure TForm1.e_Click(Sender: TObject);
      begin

      end; // e_

    procedure TForm1.f_Click(Sender: TObject);
      begin

      end; // f_

    procedure TForm1.g_Click(Sender: TObject);
      begin

      end; // g_

end.
